#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>


import string
import time

from Persistence import Persistent
from Globals import ImageFile, HTMLFile, HTML, MessageDialog, package_home
from Acquisition import Implicit
from OFS.Folder import Folder


def manage_addIrcUser(self,
					  nick, name, username, hostmask,
					  level, REQUEST={}):
	""" Add a New Authorised User """
	obj=IrcUser(nick=nick,
				name=name,
				username=username,
				domain=hostmask,
				level=level)
	self._setObject(nick, obj)
	obj=getattr(self, nick)
	get_transaction().commit()
	if REQUEST:
		return self.manage_main(self, REQUEST)
	return ''

manage_addIrcUserForm=HTMLFile('manageUsersForm', globals())
manage_editUserForm=HTMLFile('manage_editUserForm', globals())
#
# Add a User as a folder
#
# This will be expanded to create a little 'home' directory
# for users where they can store things and have little home pages
#

class IrcUser(Folder, Persistent, Implicit):

	meta_type="Irc User"
	icon="misc_/IrcBot/IrcUser.gif"


	manage_editUserForm=manage_editUserForm
	
	def __init__(self, nick, name, username, domain, level):
		self.id=nick
		self.nick=nick
		self.name=name
		self.username=username		
		self.domain=domain
		self.level=level

	def manage_editUser(self, name, username, hostmask, level, REQUEST={}):
		""" Update some user details """

		self.name=name
		self.username=username
		self.domain=hostmask
		self.level=level
		if REQUEST:
			return self.manage_editUserForm(self, REQUEST)
		return ''
		
	def matchHostMask(self, hostmask):
		# *!*blah@*.foo.com

		username,domain=string.split(hostmask,'@')
		
		if username[0] == '#':
			return 0 # We never match against spoofed ident.
		
		if ( username[0]=='~' and
			 (self.username[0] != '~' and self.username[0]!='*')):
			return 0

		elif self.username[0]=='*':
			foo = string.rindex(username, self.username[1:])
			if foo < 0:
				return 0
			if username[foo:] != self.username[1:]:
				return 0
		elif self.username != username:
			return 0
				

		if self.domain[0]=='*':
			foo= string.rindex(domain, self.domain[1:])
			if foo < 0:
				return 0
			# Make sure that *.foo.com doesn't match foo.com.au
			if domain[foo:] != self.domain[1:]:
				return 0

		elif self.domain != domain:
			return 0

		return 1

	# Allow plugins to set and get properties
	def setProperty(self, property, value):
		setattr(self, property, value)

	def getProperty(self, property, defaultValue=None):
		if hasattr(self, property):
			return getattr(self, property)
		return defaultValue

	def hasProperty(self, property):
		return hasattr(self, property)
